freeslot("MT_SOMETHINGWICKED", "S_SOMETHINGWICKED", "SPR_SOMW", "sfx_somwam", "sfx_somwck", "sfx_umsg", "sfx_swstat", "sfx_swstp1", "sfx_swstp2", "sfx_swstp3")

sfxinfo[sfx_somwam].priority = 120
sfxinfo[sfx_somwam].flags = SF_X2AWAYSOUND
sfxinfo[sfx_somwam].caption = "..."

sfxinfo[sfx_somwck].priority = 120
sfxinfo[sfx_somwck].flags = SF_X4AWAYSOUND|SF_X8AWAYSOUND
sfxinfo[sfx_somwck].caption = "Something Wicked..."

sfxinfo[sfx_umsg].caption = "Message"

sfxinfo[sfx_swstat].caption = "..."

for i = 1, 3 do
	sfxinfo[_G["sfx_swstp"..i]].caption = "Footstep"
end

rawset(_G, "somethingWickedWaypoint", function(mo)
	for mobj in mobjs.iterate() do
		if mobj.type == MT_BOSS3WAYPOINT then
			if mobj.spawnpoint and mobj.spawnpoint.args[0] == mo.curwaypoint then
				mo.targobj = mobj
			end
		end
	end
end)

local function killWicked(mo, nosound)
	if not nosound then
		for p in players.iterate do
			if not p.jumpscare_type then S_StartSound(nil, sfx_somwck, p) end
		end
	end

	local possibleSpawns = {}
	for mo in mobjs.iterate() do
		if mo.type == MT_BOSSFLYPOINT then possibleSpawns[#possibleSpawns+1] = mo end
	end

	local sp = P_RandomRange(1, #possibleSpawns)
	local spawn = possibleSpawns[sp]

	if spawn.spawnpoint then
		P_TeleportMove(mo, spawn.x, spawn.y, spawn.z)
		mo.curwaypoint = spawn.spawnpoint.args[0]
		somethingWickedWaypoint(mo)
	end
end

mobjinfo[MT_SOMETHINGWICKED] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_SOMETHINGWICKED,
	radius = 24*FRACUNIT,
	height = 128*FRACUNIT,
	flags = MF_SCENERY
}
states[S_SOMETHINGWICKED] = {SPR_SOMW, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_SOMETHINGWICKED}

addHook("MobjThinker", function(mo)
	if not S_SoundPlaying(mo, sfx_somwam) and not consoleplayer.jumpscare_type then S_StartSound(mo, sfx_somwam) end -- Ambience
	if consoleplayer.jumpscare_type then S_StopSound(mo) end -- Don't make any sound from us during the jumpscare...

	-- He'd unfortunately consistently get stuck
--	if (server.wicked_frenzy and P_SupermanLook4Players or P_LookForPlayers)(mo, 1024*FRACUNIT) then
	if P_LookForPlayers(mo, 1024*FRACUNIT*(server.wicked_frenzy and 2 or 1)) then
		mo.targobj = mo.target
		if not consoleplayer.jumpscare_type and not server.wicked_frenzy then S_StartSound(mo, sfx_somwck) end
	end

	if mo.targobj and mo.targobj.valid then
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.targobj.x, mo.targobj.y)
		P_InstaThrust(mo, mo.angle, server.wicked_frenzy and 35*FRACUNIT or 15*FRACUNIT)

		if R_PointToDist2(mo.x, mo.y, mo.targobj.x, mo.targobj.y) <= 64*FRACUNIT and mo.targobj.z <= (mo.z+256*FRACUNIT) then
			if mo.targobj.player then
				if mo.targobj.player.nojumpscare then
					-- Now kill the player
					P_KillMobj(mo.targobj, mo)

					-- Let's make him close the game in singleplayer.
					if not multiplayer then COM_BufInsertText(consoleplayer, "quit") end

					killWicked(mo)
				else
					killWicked(mo, true)

					P_SetOrigin(mo.targobj, 3264*FRACUNIT, 2112*FRACUNIT, 0)
					mo.targobj.player.jumpscare_type = P_RandomChance(FRACUNIT/50) and 2 or 1
					mo.targobj.player.jumpscare_timer = 0
					mo.targobj.player.jumpscare_appeartimer = P_RandomRange(20, 60)
					mo.targobj.player.jumpscare_rush = P_RandomRange(100, 350)
					if mo.targobj.player == consoleplayer then S_StopSound(mo) end
				end
			else
				mo.curwaypoint = $+1
				if mo.curwaypoint > 24 then mo.curwaypoint = 0 end
				somethingWickedWaypoint(mo)
			end
		end

		if mo.targobj.player and R_PointToDist2(mo.x, mo.y, mo.targobj.x, mo.targobj.y) >= 1256*FRACUNIT then
			killWicked(mo)
		end
	end

	for p in players.iterate do
		if p.mo and p.mo.valid and R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y) <= 128*FRACUNIT then
			if p.nojumpscare then
				-- Now kill the player
				P_KillMobj(p.mo, mo)

				-- Let's make him close the game in singleplayer.
				if not multiplayer then
					COM_BufInsertText(consoleplayer, "quit")
				end

				killWicked(mo)
			else
				killWicked(mo, true)

				P_SetOrigin(p.mo, 3264*FRACUNIT, 2112*FRACUNIT, 0)
				p.jumpscare_type = P_RandomChance(FRACUNIT/50) and 2 or 1
				p.jumpscare_timer = 0
				p.jumpscare_appeartimer = P_RandomRange(20, 60)
				p.jumpscare_rush = P_RandomRange(100, 350)
				if mo.targobj.player == consoleplayer then S_StopSound(mo) end
			end
		end
	end
end, MT_SOMETHINGWICKED)

-- Bypass some mod code.
addHook("ShouldDamage", function(t, i, s, d, dt)
	if (i and i.valid and i.type == MT_SOMETHINGWICKED) then return true end
end, MT_PLAYER)

-- No Jumpscare.
COM_AddCommand("nojumpscare", function(p, type)
	p.nojumpscare = not p.nojumpscare

	if p.nojumpscare then
		CONS_Printf(p, "Disabled the jumpscare.")
	else
		CONS_Printf(p, "Enabled the jumpscare.")
	end
end)